const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Activity_logsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const activity_logs = await db.activity_logs.create(
      {
        id: data.id || undefined,

        action: data.action || null,
        entity_type: data.entity_type || null,
        entity_id: data.entity_id || null,
        timestamp: data.timestamp || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await activity_logs.setUser(data.user || null, {
      transaction,
    });

    await activity_logs.setSchools(data.schools || null, {
      transaction,
    });

    return activity_logs;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const activity_logsData = data.map((item, index) => ({
      id: item.id || undefined,

      action: item.action || null,
      entity_type: item.entity_type || null,
      entity_id: item.entity_id || null,
      timestamp: item.timestamp || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const activity_logs = await db.activity_logs.bulkCreate(activity_logsData, {
      transaction,
    });

    // For each item created, replace relation files

    return activity_logs;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const activity_logs = await db.activity_logs.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.action !== undefined) updatePayload.action = data.action;

    if (data.entity_type !== undefined)
      updatePayload.entity_type = data.entity_type;

    if (data.entity_id !== undefined) updatePayload.entity_id = data.entity_id;

    if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;

    updatePayload.updatedById = currentUser.id;

    await activity_logs.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await activity_logs.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await activity_logs.setSchools(
        data.schools,

        { transaction },
      );
    }

    return activity_logs;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const activity_logs = await db.activity_logs.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of activity_logs) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of activity_logs) {
        await record.destroy({ transaction });
      }
    });

    return activity_logs;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const activity_logs = await db.activity_logs.findByPk(id, options);

    await activity_logs.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await activity_logs.destroy({
      transaction,
    });

    return activity_logs;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const activity_logs = await db.activity_logs.findOne(
      { where },
      { transaction },
    );

    if (!activity_logs) {
      return activity_logs;
    }

    const output = activity_logs.get({ plain: true });

    output.user = await activity_logs.getUser({
      transaction,
    });

    output.schools = await activity_logs.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.action) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('activity_logs', 'action', filter.action),
        };
      }

      if (filter.entity_type) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'activity_logs',
            'entity_type',
            filter.entity_type,
          ),
        };
      }

      if (filter.entity_idRange) {
        const [start, end] = filter.entity_idRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            entity_id: {
              ...where.entity_id,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            entity_id: {
              ...where.entity_id,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.timestampRange) {
        const [start, end] = filter.timestampRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.activity_logs.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('activity_logs', 'action', query),
        ],
      };
    }

    const records = await db.activity_logs.findAll({
      attributes: ['id', 'action'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['action', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.action,
    }));
  }
};
